#include <stdio.h>

#define ON 1
#define OFF 0
#define ERROR -1

#define SEND_RT_ID 20

typedef struct lidarFlags
{
    char quadHeight;
    
}lidarFlags_t;

typedef struct IMUFlags
{
    char gyro_x;
    char gyro_y;
    char gyro_z;
    char acc_x;
    char acc_y;
    char acc_z;
    char mag_x;
    char mag_y;
    char mag_z;
    
}IMUFlags_t;

typedef struct OptFlowFlags
{
    char x_flow;
    char y_flow;
    char x_filter;
    char y_filter;
    char x_velocity;
    char y_velocity;
    
}OptFlowFlags_t;

typedef struct SensorErrorFlags
{
    char consec_lidar;
    char consec_imu;
    char consec_optFlow;
    char lidar;
    char imu;
    char optFlow; 
    
}SensorErrorFlags_t;

typedef struct SensorRTFlags
{
    IMUFlags_t * imuflags;
    OptFlowFlags_t * optflowflags;
    lidarFlags_t * lidarflags;
    SensorErrorFlags_t * errorflags;
    
}SensorRTFlags_t;

SensorRTFlags_t * initializeFlags(void);

//int setDebugLevel(SensorRTFlags_t * flags, float flags);

void freeFlags(SensorRTFlags_t * flags);

int send_RT_data(struct CommDriver *comm, raw_sensor_t * data, SensorRTFlags_t * flags, int size);

u32 shift(u32 data, int position);

